const getHeight = require("../../../utils/getRheRemainingHeight"),
    _Http = getApp().globalData.http;

Page({
    /**
     * 页面的初始数据
     */
    data: {
        height: 0,
        list: [],
        content: {
            nocache: true,
            pageNumber: 1,
            pageSize: 20,
            pageTotal: 1,
            type: "应用",
            where: {}
        },
        total: 0,
    },
    //切换tab选项
    tabChange({
        detail
    }) {
        this.setData({
            "content.type": detail.name
        })
        this.getlist(true);
    },
    onReady() {
        getHeight.getHeight(".head", this).then(res => {
            this.setData({
                height: res
            })
        })
    },
    async toDetails(e) {
        const {
            objectname,
            messageid
        } = e.currentTarget.dataset.item;
        /* 已读信息 */
        _Http.basic({
            "classname": "system.message.Message",
            "method": "readMessage",
            "content": {
                messageid
            }
        }, false)
        switch (objectname) {
            case 'sat_courseware':
                this.toList("商学院")
                break;
            case 'sat_sharematerial':
                this.toList("推广素材")
                break;
            case 'sat_notice':
                this.toList("通告")
                break;
            case 'sat_submitedit':
                this.toList("提报")
                break;
            case 'sat_orderclue':
                this.toList("销售线索")
                break;
            case 'sys_payorder':
                wx.navigateTo({
                    url: `/pages/teams/index?title=付费订单`,
                })
                break;
            case 'sys_attachment':
                this.toList("营销物料")
                break;
            default:
                wx.showToast({
                    title: '当前应用暂不支持跳转',
                    icon: "none"
                })
                break;
        }
    },
    /* 前去应用列表 */
    toList(name) {
        let item = wx.getStorageSync('gridList').find(v => v.label == name);
        if (!item) return wx.showToast({
            title: `暂无进入‘${name}’应用权限`,
            icon: "none",
            mask: true
        })
        getApp().globalData.evidence(item)
    },
    getlist(init = false) {
        if (init.detail != undefined) init = init.detail;
        let content = this.data.content
        if (init) content.pageNumber = 1;
        if (content.pageNumber > content.pageTotal) return;
        _Http.basic({
            "classname": "system.message.Message",
            "method": "queryMessage",
            content
        }).then(res => {
            this.selectComponent('#ListBox').RefreshToComplete();
            if (res.msg != '成功') return wx.showToast({
                title: res.msg,
                icon: "none"
            })
            this.setData({
                total: res.total,
                list: (res.pageNumber == 1) ? res.data : this.data.list.concat(res.data),
                ['content.pageNumber']: res.pageNumber + 1,
                ['content.pageTotal']: res.pageTotal
            })
        })
    },
    onShow() {
        this.getlist(true);
        this.getTabBar().init();
    },
})