const _Http = getApp().globalData.http;
let downCount = null;
Page({
    data: {
        selectShow: false,
        userMsg: {},
        pathList: [], //功能权限
        showPicker: false
    },
    onLoad(options) {
        this.queryUserMsg();
        //美大关闭团队管理
        let authlist = getApp().globalData.queryPer.query(wx.getStorageSync('userauth'), ['通用'], ['个人中心']);
        let pathList = [{
            name: "修改登录密码",
            icon: "icon-a-wodeguanyuyingyong",
            color: "var(--warning)",
            path: `/pages/tabbar/mine/changePassword/index`
        }]
        if (authlist[0].apps.some(v => v.name == "teamManagement")) {
            this.data.pathList.unshift({
                name: "团队管理",
                icon: "icon-a-wodetuanduiguanli",
                color: "var(--assist)",
                path: `/pages/teams/index`
            });
            this.setData({
                pathList: this.data.pathList
            })
        }
    },
    /* 选择代理人 */
    onSelectUset({
        detail
    }) {
        console.log(detail)
        let that = this;
        wx.showModal({
            title: '提示',
            content: `是否确定任命“${detail.value.name}”为代理人`,
            complete: ({
                confirm
            }) => {
                if (confirm) _Http.basic({
                    "classname": "webmanage.sale.agents.agents",
                    "method": "changeAgentModel",
                    "content": {
                        "sa_agent_hrid": detail.value.sa_agent_hrid,
                        "authmodel": 3
                    }
                }).then(res => {
                    console.log("修改跟进模式", res)
                    wx.showToast({
                        title: res.msg == '成功' ? '修改成功' : res.msg,
                        icon: "none"
                    });
                    if (res.msg == '成功') that.setData({
                        "userMsg.agenthr.authmodel": 3,
                        modelList: that.data.modelList.map(v => {
                            v.disabled = v.value == 3
                            return v
                        }),
                        showPicker: false,
                        sa_agent_hrid: detail.value.sa_agent_hrid
                    })
                })
            }
        })
    },
    closePicker() {
        this.setData({
            showPicker: false
        })
    },
    openPicker() {
        this.setData({
            showPicker: true
        })
    },
    /* 选择模式 */
    onSelect({
        detail
    }) {
        this.onCancel();
        let that = this;
        if (detail.value == 3) {
            this.setData({
                showPicker: true,
                selectShow: false
            })
        } else {
            wx.showModal({
                title: '提示',
                content: `将模式改为“${detail.name}”后${detail.subname}`,
                complete: ({
                    confirm
                }) => {
                    if (confirm) _Http.basic({
                        "classname": "webmanage.sale.agents.agents",
                        "method": "changeAgentModel",
                        "content": {
                            "sa_agent_hrid": 0,
                            "authmodel": detail.value
                        }
                    }).then(res => {
                        console.log("修改跟进模式", res)
                        wx.showToast({
                            title: res.msg == '成功' ? '修改成功' : res.msg,
                            icon: "none"
                        });
                        if (res.msg == '成功') that.setData({
                            "userMsg.agenthr.authmodel": detail.value,
                            modelList: that.data.modelList.map(v => {
                                v.disabled = detail.value == v.value
                                return v
                            })
                        })
                    })
                }
            })
        }
    },
    /* 开始选择模式 */
    startSelect() {
        this.setData({
            selectShow: true
        })
    },
    /* 取消选择模式 */
    onCancel() {
        this.setData({
            selectShow: false
        })
    },
    /* 查询用户信息 */
    queryUserMsg() {
        _Http.basic({
            "classname": "common.usercenter.usercenter",
            "method": "queryUserMsg",
            "content": {
                "nochace": true
            }
        }).then(res => {
            console.log("用户信息", res)
            if (res.msg != '成功') return wx.showToast({
                title: res.msg,
                icon: "none"
            });
            switch (res.data.usertype) {
                case 1:
                    res.data.usertype = '企业职员'
                    break;
                case 21:
                    res.data.usertype = '负责人'
                    break;
                case 22:
                    res.data.usertype = '员工'
                    break;
                default:
                    res.data.usertype = ''
                    break;
            }
            this.setData({
                userMsg: res.data
            })
            if (res.data.agenthr) {
                let modelList = [{
                        name: '抢单模式',
                        subname: '待跟进线索所有人可见',
                        value: 1
                    }, {
                        name: '分配模式',
                        subname: '由负责人将销售线索转移给其他成员',
                        value: 2
                    },
                    {
                        name: '代理模式',
                        subname: '指定一位成员代理销售线索管理',
                        value: 3
                    }
                ];
                if (res.data.agenthr.authmodel != 0) modelList[res.data.agenthr.authmodel - 1].disabled = true;
                if (res.data.agenthr.authmodel == 3) _Http.basic({
                    "classname": "webmanage.sale.agents.agents",
                    "method": "getAgentModel",
                    "content": {
                        "sa_agentsid": res.data.agent.sa_agentsid
                    }
                }, false).then(res => {
                    console.log("获取经销商信息", res)
                    this.setData({
                        sa_agent_hrid: res.data.sa_agent_hrid.sa_agent_hrid
                    })
                })
                this.setData({
                    modelList
                })
            }
        })
    },
    onShow() {
        this.getTabBar().init();
        this.getUser();
    },
    /* 获取users */
    getUser() {
        _Http.basic({
            "classname": "sale.team.team",
            "method": "query_teamList",
            "content": {
                "pageNumber": 1,
                "pageSize": 999999,
                "where": {
                    "condition": ""
                }
            }
        }).then(res => {
            console.log("用户列表", res)
            if (res.msg == '成功') {
                let columnsObj = {};
                res.data.forEach(v => {
                    columnsObj[v.sa_agent_hrid] = v.name
                })
                this.setData({
                    columns: res.data,
                    columnsObj
                })
            }
        })
    },
    /* 退出登录 */
    outLogin() {
        clearTimeout(downCount);
        wx.showLoading({
            title: '正在退出...',
        })
        downCount = setTimeout(() => {
            _Http.logout().then(res => {
                wx.showToast({
                    title: '退出成功'
                });
                let loginMsg = wx.getStorageSync("loginMsg");
                wx.clearStorageSync();
                wx.setStorageSync('loginMsg', loginMsg)
                setTimeout(() => {
                    wx.reLaunch({
                        url: '/pages/login/phone',
                    })
                }, 300)
            })
        }, 300);
    },
    /* 去修改用户信息 */
    changeUserMsg() {
        let {
            name,
            phonenumber,
            attinfos,
            hr
        } = this.data.userMsg;
        wx.navigateTo({
            url: `./userMsg/index?attinfos=${JSON.stringify(attinfos)}&name=${name}&phonenumber=${phonenumber}&email=${hr.email}`
        })
    },
    /* 绑定或解绑微信 */
    bindingWechat(e) {
        if (this.data.userMsg.iswechatbinding) {
            let that = this;
            wx.showModal({
                title: "提示",
                content: "是否解除绑定",
                success: (res) => {
                    if (res.confirm) that.handleBDWechat(0);
                }
            })
        } else {
            this.handleBDWechat(1);
        }
    },
    handleBDWechat(isbinging) {
        let that = this;
        wx.getUserProfile({
            desc: '用于完善用户资料',
            success: ({
                userInfo
            }) => {
                wx.login({
                    success(res) {
                        if (res.code) _Http.basic({
                            "classname": "common.usercenter.usercenter",
                            "method": "WechatBinding",
                            content: {
                                "wechat_code": res.code,
                                isbinging, // 0解绑 1绑定
                                wechatuserinfo: userInfo
                            }
                        }).then(s => {
                            if (s.msg != '成功') return wx.showToast({
                                title: s.data,
                                icon: "none"
                            });
                            setTimeout(() => {
                                wx.showToast({
                                    title: isbinging == 0 ? '解除成功' : '绑定成功',
                                    icon: "none"
                                })
                            }, 100);
                            that.queryUserMsg();
                        })
                    }
                })
            },
            fail: () => {
                wx.showToast({
                    title: '操作失败，未获得授权',
                    icon: "none"
                })
            }
        })
    }
})