class HTTP {
    constructor() {
        let ENV = wx.getAccountInfoSync().miniProgram.envVersion;
        // ENV = 'release';
        if (ENV === 'release') { // 正式版
            this.baseUrl = "https://meida.cnyunl.com";
        } else {
            // this.baseUrl = "http://61.164.207.46:8100";
            this.baseUrl = "https://meida.cnyunl.com";
        }
        console.log("接口地址", this.baseUrl)
    }
    request({
        url,
        data = {},
        method = "POST",
        header = {
            'content-type': 'application/json'
        },
        loading = true
    }) {
        return new Promise((resolve, reject) => {
            this._request(url, resolve, reject, data, method, header, loading);
        })
    }
    _request(url, resolve, reject, data, method, header, loading) {
        if (loading) wx.showLoading({
            title: '加载中...',
            mask: true
        })
        wx.request({
            url: this.baseUrl + '/yos/rest/index' + url,
            data: data,
            method: method,
            header: header,
            timeout: 60000,
            success: (res) => {
                resolve(res.data);
                if (loading) wx.hideLoading();
            },
            fial: (err) => {
                reject(err);
                if (loading) wx.hideLoading()
            },
            complete: (res) => {
                if (res.errMsg != 'request:ok') {
                    wx.hideLoading()
                    wx.showToast({
                        title: '网络异常，请重新进入',
                        icon: "none"
                    })
                } else if (res.data.msg == '登陆状态已过期，请重新登陆！') {
                    wx.redirectTo({
                        url: '/pages/login/phone',
                    });
                    wx.showToast({
                        title: '登陆状态已过期，请重新登陆！',
                        icon: "none"
                    })
                }
            }
        })
    }
}
export {
    HTTP
}